LootRules = LibStub("AceAddon-3.0"):NewAddon("Loot Rules", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0", "AceTimer-3.0")

AceGUI = LibStub("AceGUI-3.0")


myOptions = {
    name = "Loot Rules",
    type = "group",
    args = { 
        announceRW = {
            order = 1,
            width = "double",
            name = "Raid Warning",
            desc = "Announces to the raid the item being rolled on through Raid Warning",
            type = "toggle",
            set = function(info, val) LootRules.db.profile.announceRW = val end,
            get = function(info) return LootRules.db.profile.announceRW end
        },
        rollR = {
            order = 2,
            width = "double",
            name = "Roll on Item (in Raids)",
            desc = "Announce Roll on this [item] or just ask if anyone would like the [item]",
            type = "toggle",
            set = function(info, val) LootRules.db.profile.rollR = val end,
            get = function(info) return LootRules.db.profile.rollR end
        },                    
        announceR = {
            order = 2.5,
            name = "Roll Countdown",
            desc = "Counts down over chat and announces winner (default is on)",
            type = "toggle",
            set = function(info, val) LootRules.db.profile.announceR = val end,
            get = function(info) return LootRules.db.profile.announceR end,
            disabled = function(info) return not LootRules.db.profile.rollR end,
        },
        raid = {
            order = 2.9,
            width = "half",
            name = "Roll Timer",
            desc = "Change the length of time the timer counts down when passing out loot",
            type = "input",
            set = function(info,val) LootRules.db.profile.raidTimer = val end,
		    get = function(info) return tostring(LootRules.db.profile.raidTimer) end,
            disabled = function(info) return not LootRules.db.profile.announceR end,
        },
        rollI = {
            order = 3,
            width = "double",
            name = "Roll on Item (in Instance Groups)",
            desc = "Announce Roll on this [item] or just ask if anyone would like the [item]",
            type = "toggle",
            set = function(info, val) LootRules.db.profile.rollI = val end,
            get = function(info) return LootRules.db.profile.rollI end
        }, 
        announceI = {
            order = 3.5,
            name = "Roll Countdown",
            desc = "Counts down over chat and announces winner (default is off)",
            type = "toggle",
            set = function(info, val) LootRules.db.profile.announceI = val end,
            get = function(info) return LootRules.db.profile.announceI end,
            disabled = function(info) return not LootRules.db.profile.rollI end,
        },
        instance = {
            order = 3.9,
            width = "half",
            name = "Roll Timer",
            desc = "Change the length of time the timer counts down when passing out loot",
            type = "input",
            set = function(info,val) LootRules.db.profile.iTimer = val end,
		    get = function(info) return tostring(LootRules.db.profile.iTimer) end,
            disabled = function(info) return not LootRules.db.profile.announceI end,
        },
        rollP = {
            order = 4,
            width = "double",
            name = "Roll on Item (in Parties)",
            desc = "Announce Roll on this [item] or just ask if anyone would like the [item]",
            type = "toggle",
            set = function(info, val) LootRules.db.profile.rollP = val end,
            get = function(info) return LootRules.db.profile.rollP end
        }, 
        announceP = {
            order = 4.5,
            name = "Roll Countdown",
            desc = "Counts down over chat and announces winner (default is off)",
            type = "toggle",
            set = function(info, val) LootRules.db.profile.announceP = val end,
            get = function(info) return LootRules.db.profile.announceP end,
            disabled = function(info) return not LootRules.db.profile.rollP end,
        },
        party = {
            order = 4.9,
            width = "half",
            name = "Roll Timer",
            desc = "Change the length of time the timer counts down when passing out loot",
            type = "input",
            set = function(info,val) LootRules.db.profile.pTimer = val end,
		    get = function(info) return tostring(LootRules.db.profile.pTimer) end,
            disabled = function(info) return not LootRules.db.profile.announceP end,
        },        
   }, 
}

local defaults = {
    profile = {
        raidTimer = 20,
        announceR = true,
        announceI = false,
        announceP = false,
        announceRW = true,
        rollR = true,
        rollI = false,
        rollP = false,
        iTimer = 20,
        pTimer = 10,
    },
};

local AceConfig = LibStub("AceConfig-3.0")
AceConfig:RegisterOptionsTable("Loot Rules", myOptions)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Loot Rules")

local VERSION = GetAddOnMetadata("LootRules", "Version")
local rollCmd;
local lr_frame = "unloaded";
local lr_cframe = "unloaded";
local tradeAvailable = false;
local tablePrio;
local timerCount;
local playerroll = {};
local players = {};

local equippableItems = {}


function LootRules:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("LootRulesDB", defaults)

end

function LootRules:OnEnable()
    LootRules:RegisterComm("LootRulesOCR")
    --Check If player is in a group then register this command
    LootRules:RegisterEvent("CHAT_MSG_LOOT");
    rollCmd = SLASH_RANDOM1:upper(); -- /roll

    LootRules:RegisterChatCommand("lr", "ChatCommand")

    test()
end

function LootRules:ChatCommand(input)
    
	if not input or input:trim() == "" then 
        print("Please type /lr then shift+click the item you would like to trade")
    elseif string.find(input, "Hitem:") then
        item = strtrim(input);
        LR_CollectItemInformation(item)
	end
end

function test()
	local id = 147172
    local _,id = GetItemInfo(id); 

	--local id = "|cffa335ee|Hitem:134499::::::::110:102::23:3:1727:1497:3336|h[Raven Filigree Pendant]|h|r"
    --local _,dItemLink,dItemRarity,dBaseItemLvl, _, dItemClass, dItemSubClass, _, dItemSlot = GetItemInfo(id); 
    LootRules:Print("Parsed: "..id); 
    LR_CollectItemInformation(id)
end

function LootRules:CHAT_MSG_LOOT(n, lootmsg)
    if(IsInGroup()) then
		if string.find(lootmsg, "You receive loot") then
          local bulk = string.match(lootmsg, "You receive loot: (.+)%.");        
          local _,_,_,_, _, dItemClass, dItemSubClass = GetItemInfo(bulk);    
          if(dItemClass == "Armor" or dItemClass == "Jewelry" or dItemClass == "Weapon" or (dItemClass == "Gem" and dItemSubClass == "Artifact Relic")) then                 
                LR_CollectItemInformation(bulk)
          end
      end
    end
end

function LR_CollectItemInformation(droppedItemLink)
    local _,dItemLink,dItemRarity,dBaseItemLvl, _, dItemClass, dItemSubClass, _, dItemSlot = GetItemInfo(droppedItemLink);    
                        
    if(LR_CheckRarity(droppedItemLink))then
        local isTradable = false;
        --Find real dropped item Level (seems fixed)
        local dItemLvl = LR_FindCorrectItemLevel(droppedItemLink)

        --LootRules:Print("Parsed: "..dItemLink.." Base ilvl: "..dBaseItemLvl.." class: "..dItemClass.." Sub: "..dItemSubClass.." Slot: "..dItemSlot); 

        -- Check Relics
        if( dItemSubClass == "Artifact Relic") then
            isTradable = true;
        else

            local slotId = LR_GetInventorySlot(dItemSlot)
        
            --Get Current Worn Items ilvl
            local eItemLvl = LR_GetWorniLvl(slotId);

            if(eItemLvl >= dItemLvl) then
                isTradable = true;
            end

            if(Slot == "FINGER0SLOT") then
                Slot = "FINGER1SLOT";
            
                local eItemLvl = LR_GetWorniLvl(slotId);

                if(eItemLvl >= dItemLvl) then
                    isTradable = true;
                end

            elseif (Slot == "TRINKET0SLOT") then
                Slot = "TRINKET1SLOT";

                local eItemLvl = LR_GetWorniLvl(slotId);

                if(eItemLvl >= dItemLvl) then
                    isTradable = true;
                end
            end
       
            --local itemId = GetInventoryItemID("player", slotId)
            GetInventoryItemsForSlot(slotId, equippableItems)
            for locationBitstring, itemID in pairs(equippableItems) do
                local player, bank, bags, voidstorage, slot, bag = EquipmentManager_UnpackLocation(locationBitstring)    
                    
                if(tostring(bags) == "true") then
                    link = GetContainerItemLink(bag, slot)   
                    bItemLvl = LR_FindCorrectItemLevel(link)
                        
                    --Take the link and break down the item from there

                    --Check bagged items ilvl is higher than the dropped item
                    if(bItemLvl >= dItemLvl) then
                        isTradable = true;
                    
                    end
                end
            end    
        end
        
        if(isTradable == true) then
            print("Item is now tradable");
            LR_CheckItemUseableForGroup(droppedItemLink);
        end
    end
end

--Get the Slot declaration for inventory searches
function LR_GetInventorySlot(itemSlot)
    local _, type = strsplit("_", itemSlot);

    if(type == "CLOAK") then
        type = "Back";
    end

    if (type == "HAND") then
        type = "HANDS";
    end

    if string.find(itemSlot, "WEAPON") then
        type = string.sub(type, 7);
    elseif string.find(itemSlot, "RANGED") then
        type = "Ranged";
    end

    if(type == "ROBE") then
        type = "CHEST";
    end

    local realSlot = type .. "SLOT"

    if(realSlot == "FINGERSLOT") then
        realSlot = "FINGER0SlOT"
    elseif(realSlot == "TRINKETSLOT") then
        realSlot = "TRINKET0SLOT"
    end
    
    local slotId, _, checkRelic = GetInventorySlotInfo(realSlot)

    return slotId
end

--Get current worn items ilvl via slotid
function LR_GetWorniLvl(slotId)   
    --Current Item worn
    local iLink = GetInventoryItemLink("player",slotId)
    --print("The worn link is: ", iLink:gsub("|", "||"));
    local eItemLvl = LR_FindCorrectItemLevel(iLink)

    --Check worn item's ilvl is higher than the dropped item
    --print("ItemLvl = "..eItemLvl.." of: "..iLink)
    return eItemLvl
end

--Check the item links for the correct item level of the item and return it
function LR_FindCorrectItemLevel(link)    
    --TODO clean up unneeded variables
    --Seems to be fixed since 7.1 Commented out just in case the code is needed again in the future
--    local _, _, Color, _, itemId, _, _, _, _, _,
--    _, _, LinkLvl, specializationID, upgradeId, instanceDifficultyId, numBonusIds, bonusId1, bonusId2, bonusId3, Name = string.find(link,
--    "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")

--    local _, _,_,itemLvl = GetItemInfo(itemId);
--    --print("Bonus: "..numBonusIds.." 1: "..bonusId1)
--    local ilvl = tonumber(itemLvl)
--    --Excluding legendary items from the ilvl adjustment
--    if(tonumber(numBonusIds) ~= nil and Color ~= "ff8000") then
--        if(tonumber(numBonusIds) > 3) then
--            local addediLvl = tonumber(bonusId3) - 1472 
--            ilvl = ilvl + addediLvl
--        elseif(tonumber(numBonusIds) > 1) then
--            local addediLvl = tonumber(bonusId2) - 1472 
--            ilvl = ilvl + addediLvl
--        elseif(tonumber(numBonusIds) > 0) then
--            local addediLvl = tonumber(bonusId1) - 1472 
--            ilvl = ilvl + addediLvl
--        end
--    end
    local _,_,_,ilvl = GetItemInfo(link);   
    
    return ilvl
end

--Check the item links for the correct item rarity and return it as bool
function LR_CheckRarity(link)
    --print("The escaped link is: ", dItemLink:gsub("|", "||"));
    local _,_,dItemRarity = GetItemInfo(link);  
    if(dItemRarity == 2) then

        --Get color of the item from the itemlink
        local _, _, Color = string.find(link,
        "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")

        Color = "ff"..Color

        --Check rarity value
        local r, g, b, hex = GetItemQualityColor(dItemRarity)

        --If value's color is different to itemlink then
        if(Color ~= hex) then
            return true
        else
            return false
        end
    elseif(dItemRarity > 2) then
        return true
    else
        return false
    end
end

--Check against the group to see if the item is useful for anyone else
function LR_CheckItemUseableForGroup(link)
    local name, type = GetInstanceInfo();
    --if(type ~= "none" and type ~= "scenario" and type ~= "pvp" and type ~= "arena") then 
        tablePrio = LootRules:PriorityTable()
        local classes = {};
        --Check database with item to find out who can use it
        local _,_,_,_, _, dItemClass, dItemSubClass, _, dItemSlot = GetItemInfo(link);

        clearTable(players);

        --Find classes that are in the group that match items useage
        for i=1, GetNumGroupMembers() do
            local pname, prank, psubgroup, plevel, pclass, pfileName, pzone, ponline, pisDead, prole, pisML = GetRaidRosterInfo(i);
            --print(dItemSubClass);
            --print(pclass);
            --print(pfileName);
            for _, value in ipairs(tablePrio) do            
                -- Include trinkets/Jewelry
                if(dItemSubClass == "Miscellaneous" or dItemSlot == "INVTYPE_CLOAK" or dItemSubClass == "Artifact Relic") then
                    table.insert(players, "all");                
                    break;
                elseif((value.class == pclass and dItemSubClass == value.Armor) and pname ~= GetUnitName("player")) then
                    table.insert(players, pname);
                    --TODO Possibly make it record all players its valuable for and search their gear to check

                end
            end
        end   
    
        --If there is then check their gear to see what they have and store it for loot givers screen
        if(tablelength(players) > 0) then
            --Send request to loot giver to see if they wish to trade the item
            LR_ConfirmWindow(link);
        --DEBUG
        else        
            print("No eligible players found");
            LR_ConfirmWindow(link);
        end        
    --end
    
end

--Ask if player wants to trade item
function LR_ConfirmWindow(link)
    lr_frame  = CreateFrame("frame", "LR_Frame", UIParent)
    lr_frame.width  = 220
    lr_frame.height = 100
    lr_frame:SetFrameStrata("FULLSCREEN_DIALOG")
    lr_frame:SetSize(lr_frame.width, lr_frame.height)
    lr_frame:SetPoint("CENTER", UIParent, "CENTER", 0, lr_frame.height)
    lr_frame:SetBackdrop({
	    bgFile   = "Interface\\DialogFrame\\UI-DialogBox-Background",
	    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	    tile     = true,
	    tileSize = 16,
	    edgeSize = 16,
	    insets   = { left = 2, right = 2, top = 2, bottom = 2 }
    })
    lr_frame:SetBackdropColor(0, 0, 0, 1)
    lr_frame:SetBackdropBorderColor(0.4, 0, 0, 1)
    lr_frame:EnableMouse(true)

    -- Make movable/resizable
    lr_frame:SetMovable(true)
    lr_frame:RegisterForDrag("LeftButton")
    lr_frame:SetScript("OnDragStart", lr_frame.StartMoving)
    lr_frame:SetScript("OnDragStop", lr_frame.StopMovingOrSizing)
    
    
    --tinsert(UISpecialFrames, "LR_Frame")

    -- Yes button
    local yesBtn = CreateFrame("Button", nil, lr_frame, "UIPanelButtonTemplate")
    yesBtn:SetPoint("CENTER", -40, -30)
    yesBtn:SetHeight(15)
    yesBtn:SetWidth(80)
    yesBtn:SetText("Yes")
    yesBtn:SetScript("OnClick", function(self)
        HideParentPanel(self)
        LR_OpenTrade(link)	    
    end)
    lr_frame.yesBtn = yesBtn

    -- No button
    local noBtn = CreateFrame("Button", nil, lr_frame, "UIPanelButtonTemplate")
    noBtn:SetPoint("CENTER", 40, -30)
    noBtn:SetHeight(15)
    noBtn:SetWidth(80)
    noBtn:SetText("No")
    noBtn:SetScript("OnClick", function(self)
	    HideParentPanel(self)
    end)
    lr_frame.noBtn = noBtn

    -- Question Label
    local qLbl = lr_frame:CreateFontString("qLbl")
    qLbl:SetPoint("CENTER", 0, -8)
    qLbl:SetTextColor(1, 1, 1, 1)
    qLbl:SetJustifyH("CENTER")
    qLbl:SetFontObject(GameFontNormal)
    qLbl:SetText("Do you want to trade this item?")
    lr_frame.qLbl = qLbl

    -- ScrollingMessageFrame
    local messageFrame = CreateFrame("ScrollingMessageFrame", nil, lr_frame)
    messageFrame:SetPoint("CENTER", 0, 40)
    messageFrame:SetSize(lr_frame.width, lr_frame.height - 50)
    messageFrame:SetFontObject(GameFontNormal)
    messageFrame:SetTextColor(1, 1, 1, 1) -- default color
    messageFrame:SetJustifyH("CENTER")
    messageFrame:SetHyperlinksEnabled(true)
    messageFrame:SetFading(false)
    messageFrame:SetMaxLines(1)  
    messageFrame:SetScript("OnHyperlinkClick", function(messageFrame) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
	messageFrame:SetScript("OnHyperlinkLeave", function(messageFrame) GameTooltip:Hide() end)      
    lr_frame.messageFrame = messageFrame
    messageFrame:Clear()
    messageFrame:AddMessage(link)

end

--Post Message about loot drop
function LR_OpenTrade(link)    
    
    chatType = "SAY"
    if(IsInGroup(LE_PARTY_CATEGORY_INSTANCE)) then
        chatType = "INSTANCE_CHAT"
    elseif(IsInRaid()) then
        chatType = "RAID"    
    elseif(IsInGroup()) then
        chatType = "PARTY"
    end

    --print("{rt1} Please Roll for "..link.." {rt1}");
    local _,ilink = GetItemInfo(link); 
    if(chatType == "RAID") then
        --Send information to other users addon
        --if(tablelength(players) > 0) then
        --    for _, value in pairs(players) do
        --        if(value == "all") then
        --            LootRules:SendCommMessage("LootRulesOCR", link, "RAID");
        --            break;
        --        else
        --            LootRules:SendCommMessage("LootRulesOCR", link, "WHISPER", value);
        --        end
        --    end
        --end
        
        if(LootRules.db.profile.rollR == true) then
            if(LootRules.db.profile.announceRW == true) then
                SendChatMessage("{rt1} Please Roll for "..ilink.." {rt1}", "RAID_WARNING")
            else
                SendChatMessage("{rt1} Please Roll for "..ilink.." {rt1}", chatType)
            end
            LootRules:SendCommMessage("LootRulesOCR", link, chatType);
            if(LootRules.db.profile.announceR == true) then
                LR_Countdown(chatType, ilink, LootRules.db.profile.raidTimer)
            end
        else
            if(LootRules.db.profile.announceRW == true) then
                SendChatMessage("{rt1} Would anyone like "..ilink.."? {rt1}", "RAID_WARNING")
            else
                SendChatMessage("{rt1} Would anyone like "..ilink.."? {rt1}", chatType)  
            end
        end
    else
        --Party text to just ask if they want the item and not roll for it
        if(tablelength(players) > 0) then
            if(LootRules.db.profile.rollP == true) then
                SendChatMessage("{rt1} Please Roll for "..ilink.." {rt1}", chatType)
                LootRules:SendCommMessage("LootRulesOCR", link, chatType);
                if(LootRules.db.profile.announceP == true) then
                    LR_Countdown(chatType, ilink, LootRules.db.profile.pTimer)
                end
            elseif(LootRules.db.profile.rollI == true) then
                SendChatMessage("{rt1} Please Roll for "..ilink.." {rt1}", chatType)
                LootRules:SendCommMessage("LootRulesOCR", link, chatType);
                if(LootRules.db.profile.announceI == true) then
                    LR_Countdown(chatType, ilink, LootRules.db.profile.iTimer)
                end
            else
                -- form a string of players names
                local names = "";
                for i,v in pairs(players) do    
                    if(v ~= "all") then            
                        names = names..v.." ";
                    end
                end
                if( names == "" ) then
                    SendChatMessage("{rt1} Would anyone like "..ilink.."? {rt1}", chatType)                
                else
                    SendChatMessage("{rt1} "..names.."would you like this: "..ilink.."? {rt1}", chatType)
                end
            end
        else
            if(LootRules.db.profile.announceP == true) then
                SendChatMessage("{rt1} Please Roll for "..ilink.." {rt1}", chatType)
            elseif(LootRules.db.profile.announceI == true) then
                SendChatMessage("{rt1} Please Roll for "..ilink.." {rt1}", chatType)
            else
                SendChatMessage("{rt1} Would anyone like "..ilink.."? {rt1}", chatType)
            end
        end
    end
--List rolls and show spec and current equiped items
    
end

function LR_Countdown(chatType, link, timer)
    SendChatMessage("Countdown of "..timer.." seconds begins now", chatType)

    --Begin roll timer
    timerCount = 0
    lootTimer = LootRules:ScheduleRepeatingTimer("EndTrade",1);

    --Open Roll Window
    LR_RollWindowHost(link)

    --Do /roll via button, and track manual /roll
    clearTable(playerroll);
    qLbl:SetText("Trade Window is Open!");
    LootRules:RegisterEvent("CHAT_MSG_SYSTEM");

end

function LR_RollWindowHost(link)
    local lr_frame  = CreateFrame("frame", "LR_Frame", UIParent)
    lr_frame.width  = 220
    lr_frame.height = 200
    lr_frame:SetFrameStrata("FULLSCREEN_DIALOG")
    lr_frame:SetSize(lr_frame.width, lr_frame.height)
    lr_frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
    lr_frame:SetBackdrop({
	    bgFile   = "Interface\\DialogFrame\\UI-DialogBox-Background",
	    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	    tile     = true,
	    tileSize = 16,
	    edgeSize = 16,
	    insets   = { left = 2, right = 2, top = 2, bottom = 2 }
    })
    lr_frame:SetBackdropColor(0, 0, 0, 1)
    lr_frame:EnableMouse(true)

    -- Make movable/resizable
    lr_frame:SetMovable(true)
    lr_frame:RegisterForDrag("LeftButton")
    lr_frame:SetScript("OnDragStart", lr_frame.StartMoving)
    lr_frame:SetScript("OnDragStop", lr_frame.StopMovingOrSizing)

    -- Close button
    local noBtn = CreateFrame("Button", nil, lr_frame, "UIPanelButtonTemplate")
    noBtn:SetPoint("BOTTOM", 0, 10)
    noBtn:SetHeight(15)
    noBtn:SetWidth(80)
    noBtn:SetText("Close")
    noBtn:SetScript("OnClick", function(self)
	    HideParentPanel(self)
    end)
    lr_frame.noBtn = noBtn

    -- Title Label
    qLbl = lr_frame:CreateFontString("qLbl")
    qLbl:SetPoint("Top", 0, -28)
    qLbl:SetTextColor(1, 1, 1, 1)
    qLbl:SetJustifyH("CENTER")
    qLbl:SetFontObject(GameFontNormal)
    
    lr_frame.qLbl = qLbl

    -- ItemLink
    local messageFrame = CreateFrame("ScrollingMessageFrame", nil, lr_frame)
    messageFrame:SetPoint("Top", 0, -5)
    messageFrame:SetSize(lr_frame.width, 20)
    messageFrame:SetFontObject(GameFontNormal)
    messageFrame:SetTextColor(1, 1, 1, 1) -- default color
    messageFrame:SetJustifyH("CENTER")
    messageFrame:SetHyperlinksEnabled(true)
    messageFrame:SetFading(false)
    messageFrame:SetMaxLines(1)  
    messageFrame:SetScript("OnHyperlinkClick", function(messageFrame) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
	messageFrame:SetScript("OnHyperlinkLeave", function(messageFrame) GameTooltip:Hide() end)      
    lr_frame.messageFrame = messageFrame

    messageFrame:AddMessage(link)

    -- Roll lr_frame
    rollFrame = CreateFrame("ScrollingMessageFrame", nil, lr_frame)
    rollFrame:SetPoint("Bottom", 0, 55)
    rollFrame:SetSize(lr_frame.width-20, lr_frame.height-100)
    rollFrame:SetFontObject(GameFontNormal)
    rollFrame:SetBackdrop({
	    bgFile   = "Interface\\DialogFrame\\UI-DialogBox-Background",
	    tile     = true,
	    tileSize = 16,
	    insets   = { left = 0, right = 0, top = 0, bottom = 0 }
    })
    rollFrame:SetTextColor(1, 1, 1, 1) -- default color
    rollFrame:SetJustifyH("CENTER")
    rollFrame:SetInsertMode("BOTTOM")
    rollFrame:SetFading(false)
    rollFrame:SetMaxLines(30)     
    rollFrame:SetHyperlinksEnabled(true)
    rollFrame:SetScript("OnHyperlinkClick", function(rollFrame) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
	rollFrame:SetScript("OnHyperlinkLeave", function(rollFrame) GameTooltip:Hide() end)    
    lr_frame.rollFrame = rollFrame

    -- Set up the scrollbar to work properly
    local scrollBar = CreateFrame("Slider", nil, lr_frame, "UIPanelScrollBarTemplate")
    scrollBar:SetPoint("RIGHT", lr_frame, "RIGHT", -8, 5)
    scrollBar:SetSize(15, lr_frame.height - 140)
    scrollBar:SetMinMaxValues(0, 9)
    scrollBar:SetValueStep(1)
    scrollBar.scrollStep = 1
    lr_frame.scrollBar = scrollBar

    scrollBar:SetScript("OnValueChanged", function(self, value)
           rollFrame:SetScrollOffset(select(2, scrollBar:GetMinMaxValues()) - value)
    end)

    scrollBar:SetValue(select(2, scrollBar:GetMinMaxValues()))

    lr_frame:SetScript("OnMouseWheel", function(self, delta)
	    local cur_val = scrollBar:GetValue()
	    local min_val, max_val = scrollBar:GetMinMaxValues()

	    if delta < 0 and cur_val < max_val then
		    cur_val = math.min(max_val, cur_val + 1)
		    scrollBar:SetValue(cur_val)
	    elseif delta > 0 and cur_val > min_val then
		    cur_val = math.max(min_val, cur_val - 1)
		    scrollBar:SetValue(cur_val)
	    end
    end)

    -- Winner Label
    wLbl = lr_frame:CreateFontString("wLbl")
    wLbl:SetPoint("Bottom", 0, 35)
    wLbl:SetTextColor(1, 1, 1, 1)
    wLbl:SetJustifyH("CENTER")
    wLbl:SetFontObject(GameFontNormal)
    lr_frame.wLbl = wLbl
end

--Capture Loot Rolls
function LootRules:CHAT_MSG_SYSTEM(self, rollMsg)    
    if rollMsg then
        --print(rollMsg)
        local name,roll,minRoll,maxRoll = rollMsg:match("^(.+) rolls (%d+) %((%d+)%-(%d+)%)$")
        --print(minRoll,"to",maxRoll)

        if (LR_findPlayer(name) == false and (tonumber(minRoll) == 1) and (tonumber(maxRoll) == 100)) then
            --print(name,"rolled a",roll,"out of",minRoll,"to",maxRoll)
            local class, classFileName = UnitClass(name) 
            local color = RAID_CLASS_COLORS[classFileName];
            rollFrame:AddMessage(name.." "..roll, color.r, color.g, color.b);
            --Add to list name and roll
            if(playerroll[tonumber(roll)]) then
            --Check for doubles and at the end, if that player is highest then make a reroll
            --print("Double Detected")
                pname = playerroll[tonumber(roll)];
                playerroll[tonumber(roll)] = pname..":-:"..name
            else
                table.insert(playerroll,  tonumber(roll), name)
            end

        end
    end
end

--Timer ends and ends the trade window
function LootRules:EndTrade()
    timerCount = timerCount + 1
    local maxTime = tonumber(LootRules.db.profile.raidTimer);

    if(timerCount == (maxTime/2)) then
        local countdown = maxTime - timerCount
        SendChatMessage(countdown.." seconds remaining", chatType)
    end
    if(timerCount >= (maxTime-5) and timerCount < maxTime) then
        local countdown = maxTime - timerCount
        SendChatMessage(countdown, chatType)
    end
    if (timerCount == maxTime) then
        LootRules:CancelTimer(lootTimer)
    
        LootRules:UnregisterEvent("CHAT_MSG_SYSTEM");

        SendChatMessage("{rt3}The trade window has now been closed{rt3}", chatType)
        --Update RollWindows
        qLbl:SetText("Trade Window has Closed!")
    
        Winner = "";
        Roll = "";
        --print(tablelength(playerroll));
        if(tablelength(playerroll) == 1) then
            for name, line in pairs(playerroll) do
                Roll = name
                Winner = line
            end
        else
            for name, line in pairsKeySorted(playerroll) do
                Roll = name
                Winner = line
            end
        end
        --print(string.find(Winner, ":-:"))
        --Check if winner is a dupelicate number (check for - in the name)
        if string.find(Winner, ":-:") then
            --print("Reroll required")    
            local players = { strsplit(":-:", Winner) }
            local reroll = ""  
            for k, v in pairs (players) do
                if(v ~= "") then
                    reroll = reroll..", "..v;
                end
            end

            SendChatMessage("Please roll again"..reroll.." to decide the winner!", chatType)
            LR_Reroll(Winner);
        elseif(Winner ~= "") then
            --Announce winner of the loot rolls    
            wLbl:SetText("The Winner is: "..Winner.." "..Roll)
            SendChatMessage("{rt1}The Winner is: "..Winner.."{rt1}", chatType)

        else
            wLbl:SetText("No Winner")
            SendChatMessage("{rt1}There was no winner{rt1}", chatType)
        end
        --Send information to other users addon that the trade has finished
        LootRules:SendCommMessage("LootRulesOCR", "finished", "RAID")
    end
end

--Setup for Reroll
function LR_Reroll(players)
    clearTable(playerroll);
    rollFrame:Clear();
    qLbl:SetText("Trade Window is Open!");

    SendChatMessage("{rt1} Reroll for "..link.." {rt1}", chatType)
    SendChatMessage("Countdown of 20 seconds begins now", chatType)

    LootRules:RegisterEvent("CHAT_MSG_SYSTEM", LR_RerollMessages, players);
    
    LootRules:ScheduleRepeatingTimer("EndTrade",1);
end

--Catch the new reroller rolls
function LR_RerollMessages(Winner, n, rollMsg)
    --Split the winners
    local players = { strsplit(":-:", Winner) }
    
    if rollMsg then
        --print(rollMsg)
        local name,roll,minRoll,maxRoll = rollMsg:match("^(.+) rolls (%d+) %((%d+)%-(%d+)%)$")
        
        --Loop through all the joint winners to make sure only they get recorded
        for n, v in pairs(players) do
            if ((name == v) and LR_findPlayer(name) == false and (tonumber(minRoll) == 1) and (tonumber(maxRoll) == 100)) then

              rollFrame:AddMessage(name.." "..roll);
              --Add to list name and roll
              if(playerroll[tonumber(roll)]) then
              --Check for doubles and at the end, if that player is highest then make a reroll
                print("Double Detected")
                pname = playerroll[tonumber(roll)];
                playerroll[tonumber(roll)] = pname..":-:"..name
              else
                table.insert(playerroll,  tonumber(roll), name)
              end
              break;
            end
        end
    end
end

-------------------
--  Client Side  --
-------------------

-- Communications send/recieve
function LootRules:OnCommReceived(prefix, message, distribution, sender)    
    local playerName = UnitName("player")
	if (sender ~= playerName) then
        if (prefix == "LootRulesOCR") then
            -- find out if the message is an itemlink
            if string.find(message, "Hitem:") then
                -- hide the trade window         
                if(lr_frame ~= "unloaded") then       
                    show = lr_frame:IsVisible();
                    if(show == true and tradeAvailable == false) then
                        tradeAvailable = true
                        lr_frame:Hide();
                    end
                end
                -- Receive info of item
                -- Check first if its useable
                if(LR_CheckItemUseableForPlayer(message) == true) then
                    LR_ClientRollWindow(message)
                end
            elseif(message == "finished") then
                -- queue if the client wants to trade item
                if(lr_frame ~= "unloaded" and tradeAvailable == true) then    
                    tradeAvailable = false;             
                    lr_frame:Show();                        
                end
                if(lr_cframe ~= "unloaded") then
                    show = lr_cframe:IsVisible();
                    if(show == true) then   
                        lr_cframe:Hide();
                        lr_cframe = nil;
                    end
                end
            end       
        end
    end
end

-- Open Roll window
function LR_ClientRollWindow(link)
    lr_cframe  = CreateFrame("frame", "LR_Frame", UIParent)
    lr_cframe.width  = 220
    lr_cframe.height = 100
    lr_cframe:SetFrameStrata("FULLSCREEN_DIALOG")
    lr_cframe:SetSize(lr_cframe.width, lr_cframe.height)
    lr_cframe:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
    lr_cframe:SetBackdrop({
	    bgFile   = "Interface\\DialogFrame\\UI-DialogBox-Background",
	    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	    tile     = true,
	    tileSize = 16,
	    edgeSize = 16,
	    insets   = { left = 2, right = 2, top = 2, bottom = 2 }
    })
    lr_cframe:SetBackdropColor(0, 0, 0, 1)
    lr_cframe:SetBackdropBorderColor(0,0,0.8,1)
    lr_cframe:EnableMouse(true)

    -- Make movable/resizable
    lr_cframe:SetMovable(true)
    lr_cframe:RegisterForDrag("LeftButton")
    lr_cframe:SetScript("OnDragStart", lr_cframe.StartMoving)
    lr_cframe:SetScript("OnDragStop", lr_cframe.StopMovingOrSizing)
    

    --tinsert(UISpecialFrames, "LR_Frame")

    -- Roll button
    local rollBtn = CreateFrame("Button", nil, lr_cframe, "UIPanelButtonTemplate")
    rollBtn:SetPoint("CENTER", -40, -30)
    rollBtn:SetHeight(15)
    rollBtn:SetWidth(80)
    rollBtn:SetText("Roll")    
    -- Allow to /roll
    rollBtn:SetScript("OnClick", function(self)
        HideParentPanel(self)
        hash_SlashCmdList[rollCmd](""); -- /roll 
    end)
    lr_cframe.rollBtn = rollBtn

    -- No button
    local noBtn = CreateFrame("Button", nil, lr_cframe, "UIPanelButtonTemplate")
    noBtn:SetPoint("CENTER", 40, -30)
    noBtn:SetHeight(15)
    noBtn:SetWidth(80)
    noBtn:SetText("Pass")
    noBtn:SetScript("OnClick", function(self)
	    HideParentPanel(self)
    end)
    lr_cframe.noBtn = noBtn

    -- Question Label
    local qLbl = lr_cframe:CreateFontString("qLbl")
    qLbl:SetPoint("CENTER", 0, -8)
    qLbl:SetTextColor(1, 1, 1, 1)
    qLbl:SetJustifyH("CENTER")
    qLbl:SetFontObject(GameFontNormal)
    qLbl:SetText("Would you like this item?")
    lr_cframe.qLbl = qLbl

    -- ScrollingMessageFrame
    local messageFrame = CreateFrame("ScrollingMessageFrame", nil, lr_cframe)
    messageFrame:SetPoint("CENTER", 0, 40)
    messageFrame:SetSize(lr_cframe.width, lr_cframe.height - 50)
    messageFrame:SetFontObject(GameFontNormal)
    messageFrame:SetTextColor(1, 1, 1, 1) -- default color
    messageFrame:SetJustifyH("CENTER")
    messageFrame:SetHyperlinksEnabled(true)
    messageFrame:SetFading(false)
    messageFrame:SetMaxLines(1)  
    messageFrame:SetScript("OnHyperlinkClick", function(messageFrame) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
	messageFrame:SetScript("OnHyperlinkLeave", function(messageFrame) GameTooltip:Hide() end)      
    lr_cframe.messageFrame = messageFrame
    messageFrame:Clear()
    messageFrame:AddMessage(link)

end

function LR_CheckItemUseableForPlayer(link)
    tablePrio = LootRules:PriorityTable()
    --Check database with item to find out who can use it
    local _,_,_,_, _, dItemClass, dItemSubClass, _, dItemSlot = GetItemInfo(link);
    
    --Find classes that are in the group that match items useage
    local _, pclass = UnitClass("player");

    for _, value in ipairs(tablePrio) do            
            -- Include trinkets/Jewelry
        local class = string.upper(value.class);

        if(dItemSubClass == "Miscellaneous" or dItemSlot == "INVTYPE_CLOAK" or dItemSubClass == "Artifact Relic") then
            return true;      
        elseif(class == pclass and dItemSubClass == value.Armor) then
            return true;
        end
    end
    
    return false;
    
end

-----------------
--  Functions  --
-----------------

--Find if the player is in the playerroll array
function LR_findPlayer(name)
    local check = false
    for i,v in pairs(playerroll) do
        if v == name then
            check = true
        end
    end

    return check
end

function pairsKeySorted(t, f)
    local a = {}    
    for n in pairs(t) do
        table.insert(a, n)
    end    
    table.sort(a, f)
 
    local i = 1      -- iterator variable
    local iter = function ()   -- iterator function
        i = i + 1
        if a[i] == nil then
            return nil
        else
            return a[i], t[a[i]]
        end
    end
 
    return iter
end

function tablelength(T) 
    if(T ~= nil) then
	    local c = 0 
	    for _ in pairs(T) do c = c + 1 end 
	    return c 
    end
end

function clearTable(T)
    if(T ~= nil) then
        for k in pairs (T) do
            T [k] = nil
        end
    end
end

--Debugging ItemLinks
function LR_ShowItemLink()
    local _, link,_,itemLvl = GetItemInfo(134197);
    print("Original: "..itemLvl..link);
    
    print("|cffa335ee|Hitem:134197::::::::110:577::30:3:3397:1512:3336|h[Biornskin Vest]|h|r")
    print("|cffa335ee|Hitem:134197::::::::110:577::30:3:3397:1532:3337|h[Biornskin Vest]|h|r")
    print("|cffa335ee|Hitem:134197::::::::110:577::5:3:1805:1497:3336|h[Biornskin Vest]|h|r")
    print("|cffa335ee|Hitem:134197::::::::110:577::5:3:1805:1532:3337|h[Biornskin Vest]|h|r")
    print("|cffa335ee|Hitem:134197::::::::110:577::16:3:3414:1552:3337|h[Biornskin Vest]|h|r")
    
    --print("|cffa335ee|Hitem:139066::::::::110:577::5:3:1805:1532:3337|h[Tranquil Bough Wristwraps]|h|r")

    --Instance Number
    --30 = Nothing
    --5 = Heroic

    --BonusID1


    --BonusID2 -- Base = 1472 ( Base - ID2 = difference )
    --1497 = 835
    --1512 = 850
    --1532 = 870


    --Last Number
    --3336 = Warforged
    --3337 = Titanforged
end
